Index: TvEngine3/TVLibrary/TVDatabase/Channel.cs
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/Channel.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TVDatabase/Channel.cs	(working copy)
@@ -637,8 +637,26 @@
     {
       //IFormatProvider mmddFormat = new CultureInfo(String.Empty, false);
       //DateTime startTime = DateTime.Now;
+      SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof(Program));
+      sb.AddConstraint(Operator.Equals, "idChannel", IdChannel);
+      sb.AddConstraint(Operator.GreaterThan, "endTime", date);
+      sb.AddConstraint(Operator.LessThanOrEquals, "startTime", date);
+      sb.AddOrderByField(true, "startTime");
+      sb.SetRowLimit(1);
+      SqlStatement stmt = sb.GetStatement(true);
+      IList<Program> programs = ObjectFactory.GetCollection<Program>(stmt.Execute());
+      if (programs.Count == 0)
+      {
+        return null;
+      }
+      return programs[0];
+    }
+
+    public Program GetProgramAt(DateTime date, int seriesId)
+    {
       SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (Program));
       sb.AddConstraint(Operator.Equals, "idChannel", IdChannel);
+      sb.AddConstraint(Operator.Equals, "seriesId", seriesId);
       sb.AddConstraint(Operator.GreaterThan, "endTime", date);
       sb.AddConstraint(Operator.LessThanOrEquals, "startTime", date);
       sb.AddOrderByField(true, "startTime");
Index: TvEngine3/TVLibrary/TVDatabase/Program.cs
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/Program.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TVDatabase/Program.cs	(working copy)
@@ -50,6 +50,8 @@
     [TableColumn("starRating", NotNull = true)] private int starRating;
     [TableColumn("classification", NotNull = true)] private string classification;
     [TableColumn("parentalRating", NotNull = true)] private int parentalRating;
+    [TableColumn("seriesId", NotNull = false, NullValue = 0)] private int seriesId;
+    [TableColumn("seriesTermination", NotNull = false, NullValue = 0)] private int seriesTermination;
 
     #endregion
 
@@ -99,6 +101,7 @@
       this.parentalRating = parentalRating;
     }
 
+
     /// <summary> 
     /// Create an object from an existing row of data. This will be used by Gentle to 
     /// construct objects from retrieved rows. 
@@ -537,6 +540,38 @@
       }
     }
 
+    /// <summary>
+    /// Series Id is used only for Sky UK/IT/AU at the moment for 'series link' functionality
+    /// </summary>
+    public int SeriesId
+    {
+      get
+      {
+        return seriesId;
+      }
+      set
+      {
+        isChanged |= seriesId != value;
+        seriesId = value;
+      }
+    }
+
+    /// <summary>
+    /// Does this program terminate a series?  The schedule can be deleted when it is time to record this program is so
+    /// </summary>
+    public int SeriesTermination
+    {
+      get
+      {
+        return seriesTermination;
+      }
+      set
+      {
+        isChanged |= seriesTermination != value;
+        seriesTermination = value;
+      }
+    }
+
     #endregion
 
     #region Storage and Retrieval
@@ -893,6 +928,26 @@
       return ObjectFactory.GetCollection<Program>(stmt.Execute());
     }
 
+    /// <summary>
+    /// Gets all programs with the specified series id (series link - Sky UK/IT/AU)
+    /// </summary>
+    /// <param name="seriesId"></param>
+    /// <param name="channelId"></param>
+    /// <returns></returns>
+    public static IList<Program> RetrieveBySeriesId(int seriesId, int channelId)
+    {
+      SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof(Program));
+
+      //  Add constraints (series id and channel id)
+      sb.AddConstraint(Operator.Equals, "idChannel", channelId);
+      sb.AddConstraint(Operator.Equals, "seriesId", seriesId);
+
+      SqlStatement stmt = sb.GetStatement(true);
+
+      // execute the statement/query and create a collection of User instances from the result set
+      return ObjectFactory.GetCollection<Program>(stmt.Execute());
+    }
+
     public static void ResetPendingState(int idProgram)
     {
       Program prg = Program.Retrieve(idProgram);
@@ -1169,6 +1224,10 @@
                               OriginalAirDate,
                               SeriesNum, EpisodeNum, EpisodeName, EpisodePart, StarRating, Classification,
                               parentalRating);
+
+      p.SeriesId = SeriesId;
+      p.SeriesTermination = SeriesTermination;
+
       return p;
     }
 
Index: TvEngine3/TVLibrary/TVDatabase/Schedule.cs
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/Schedule.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TVDatabase/Schedule.cs	(working copy)
@@ -43,7 +43,8 @@
     EveryTimeOnEveryChannel,
     Weekends,
     WorkingDays,
-    WeeklyEveryTimeOnThisChannel
+    WeeklyEveryTimeOnThisChannel,
+    SeriesLink,
   }
 
   /// <summary>
@@ -98,6 +99,8 @@
     private int recommendedCard;
     [TableColumn("series", NotNull = true)]
     private bool series;
+    [TableColumn("seriesId", NotNull = false, NullValue = 0)]
+    private int seriesId;
 
     #endregion
 
@@ -451,6 +454,21 @@
       }
     }
 
+    /// <summary>
+    /// Gets/Sets the series id
+    /// </summary>
+    public int SeriesId
+    {
+      get
+      {
+        return seriesId;
+      }
+      set
+      {
+        seriesId = value;
+      }
+    }
+
     #endregion
 
     #region Storage and Retrieval
@@ -759,6 +777,24 @@
               }
             }
             break;
+
+          case (int)ScheduleRecordingType.SeriesLink:
+            List<Program> programsSeriesLink =
+              (List<Program>)
+              Program.RetrieveBySeriesId(schedule.SeriesId, schedule.ReferencedChannel().IdChannel);
+
+            if (programsSeriesLink != null && programsSeriesLink.Count > 0)
+            {
+              foreach (Program programSeriesLink in programsSeriesLink)
+              {
+                if (!schedule.IsSerieIsCanceled(programSeriesLink.StartTime))
+                {
+                  SetAdvScheduleState(schedule, clear, programSeriesLink);
+                }
+              }
+            }
+
+            break;
         }
       }
       catch (Exception e)
@@ -788,7 +824,8 @@
     {
       if (schedule.ScheduleType == (int)ScheduleRecordingType.EveryTimeOnEveryChannel ||
           schedule.ScheduleType == (int)ScheduleRecordingType.EveryTimeOnThisChannel ||
-		  schedule.ScheduleType == (int)ScheduleRecordingType.WeeklyEveryTimeOnThisChannel)
+		  schedule.ScheduleType == (int)ScheduleRecordingType.WeeklyEveryTimeOnThisChannel ||
+          schedule.ScheduleType == (int)ScheduleRecordingType.SeriesLink)
       {
         return false;
       }
@@ -1170,6 +1207,16 @@
             return true;
           }
           break;
+        case ScheduleRecordingType.SeriesLink:
+          if (program.SeriesId == SeriesId && program.IdChannel == IdChannel)
+          {
+            if (filterCanceledRecordings && IsSerieIsCanceled(program.StartTime, program.IdChannel))
+            {
+              return false;
+            }
+            return true;
+          }
+          break;
         case ScheduleRecordingType.Daily:
           if (program.IdChannel == IdChannel)
           {
@@ -1410,6 +1457,9 @@
       schedule.series = series;
       schedule.idSchedule = idSchedule;
       schedule.isChanged = false;
+
+      schedule.seriesId = seriesId;
+
       return schedule;
     }
 
Index: TvEngine3/TVLibrary/TVDatabase/TuningDetail.cs
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/TuningDetail.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TVDatabase/TuningDetail.cs	(working copy)
@@ -654,6 +654,32 @@
     }
 
     /// <summary>
+    /// Finds all matching tuning detail entries
+    /// </summary>
+    /// <param name="frequency"></param>
+    /// <param name="frequenyTolerance"></param>
+    /// <param name="polarisation"></param>
+    /// <param name="innerFEC"></param>
+    /// <param name="symbolRate"></param>
+    /// <param name="networkId"></param>
+    /// <returns></returns>
+    public static IList<TuningDetail> Find(int frequency, int frequenyTolerance, int polarisation, int innerFEC, int symbolRate, int networkId)
+    {
+      SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof(TuningDetail));
+
+      sb.AddConstraint(Operator.GreaterThanOrEquals, "frequency", (frequency - frequenyTolerance));
+      sb.AddConstraint(Operator.LessThanOrEquals, "frequency", (frequency + frequenyTolerance));
+      sb.AddConstraint(Operator.Equals, "polarisation", polarisation);
+      sb.AddConstraint(Operator.Equals, "innerFecRate", innerFEC);
+      sb.AddConstraint(Operator.Equals, "symbolrate", symbolRate);
+      sb.AddConstraint(Operator.Equals, "networkId", networkId);
+
+      SqlStatement stmt = sb.GetStatement(true);
+
+      return ObjectFactory.GetCollection<TuningDetail>(stmt.Execute());
+    }
+
+    /// <summary>
     /// Persists the entity if it was never persisted or was changed.
     /// </summary>
     public override void Persist()
Index: TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/BusinessLayer.cs
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/BusinessLayer.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/BusinessLayer.cs	(working copy)
@@ -1434,6 +1434,9 @@
           Convert.ToInt32(prog["parentalRating"])
           );
 
+        p.SeriesId = Convert.ToInt32((prog.IsNull("seriesId") ? 0 : prog["seriesId"]));
+        p.SeriesTermination = Convert.ToInt32((prog.IsNull("seriesTermination") ? 0 : prog["seriesTermination"]));
+
         int idChannel = p.IdChannel;
         if (!maps.ContainsKey(idChannel))
         {
Index: TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/EpgDBUpdater.cs
===================================================================
--- TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/EpgDBUpdater.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TVDatabase/TvBusinessLayer/EpgDBUpdater.cs	(working copy)
@@ -459,6 +459,15 @@
         dbProg.OriginalAirDate = SqlDateTime.MinValue.Value; // TODO: /!\ add implementation
         dbProg.ClearRecordPendingState();
       }
+
+      //  If the epg program has series id information, copy to the program
+      if (ep.SeriesId != 0)
+      {
+        dbProg.SeriesId = ep.SeriesId;
+        dbProg.SeriesTermination = ep.SeriesTermination;
+      }
+
+
       dbProg.Persist();
     }
 
Index: TvEngine3/TVLibrary/TvLibrary.Interfaces/Epg/EpgProgram.cs
===================================================================
--- TvEngine3/TVLibrary/TvLibrary.Interfaces/Epg/EpgProgram.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvLibrary.Interfaces/Epg/EpgProgram.cs	(working copy)
@@ -34,6 +34,8 @@
     private List<EpgLanguageText> _languageText;
     private DateTime _startTime;
     private DateTime _endTime;
+    private int _seriesId;
+    private int _seriesTermination;
 
     #endregion
 
@@ -85,6 +87,24 @@
       set { _endTime = value; }
     }
 
+    /// <summary>
+    /// Gets/Sets the series id (used for 'series link' for Sky UK/IT/AU)
+    /// </summary>
+    public int SeriesId
+    {
+      get { return _seriesId; }
+      set { _seriesId = value; }
+    }
+
+    /// <summary>
+    /// Gets/Sets the series termination flag (used to designate last episode of a series for Sky UK/IT/AU)
+    /// </summary>
+    public int SeriesTermination
+    {
+      get { return _seriesTermination; }
+      set { _seriesTermination = value; }
+    }
+
     #endregion
 
     #region IComparable<EpgProgram> Members
Index: TvEngine3/TVLibrary/TvLibrary.Interfaces/Interfaces/ITVEPG.cs
===================================================================
--- TvEngine3/TVLibrary/TvLibrary.Interfaces/Interfaces/ITVEPG.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TvLibrary.Interfaces/Interfaces/ITVEPG.cs	(working copy)
@@ -46,6 +46,27 @@
   public abstract class BaseEpgGrabber : IEpgCallback
   {
     /// <summary>
+    /// EPG grab mode
+    /// </summary>
+    public enum eEPGGrabMode
+    {
+      Normal,
+      SkyUK,
+      SkyItaly,
+    }
+
+    /// <summary>
+    /// Gets the current EPG grab mode
+    /// </summary>
+    public virtual eEPGGrabMode EPGGrabMode
+    {
+      get
+      {
+        return eEPGGrabMode.Normal;
+      }
+    }
+
+    /// <summary>
     /// Gets called when epg has been cancelled
     /// Should be overriden by the class
     /// </summary>
Index: TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/TvCardDvbBase.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/TvCardDvbBase.cs	(revision 27484)
+++ TvEngine3/TVLibrary/TVLibrary/Implementations/DVB/Graphs/TvCardDvbBase.cs	(working copy)
@@ -29,11 +29,13 @@
 using TvLibrary.Interfaces.Analyzer;
 using TvLibrary.Channels;
 using TvLibrary.Implementations.Helper;
+using TvLibrary.Implementations.Helper.Providers;
 using TvLibrary.Epg;
 using TvLibrary.ChannelLinkage;
 using MediaPortal.TV.Epg;
 using TvDatabase;
 
+
 namespace TvLibrary.Implementations.DVB
 {
 
@@ -795,6 +797,9 @@
     {
       //UpdateSignalQuality(true);
       bool isLocked = false;
+      bool isPresent = false;
+      int quality = 0;
+      int strength = 0;
       DateTime timeStart = DateTime.Now;
       TimeSpan ts = timeStart - timeStart;
       while (!isLocked && ts.TotalSeconds < _parameters.TimeOutTune)
@@ -806,9 +811,14 @@
           try
           {
             stat.get_SignalLocked(out isLocked);
-            if (isLocked)
+            stat.get_SignalPresent(out isPresent);
+            stat.get_SignalQuality(out quality);
+            stat.get_SignalStrength(out strength);
+            Log.Log.WriteFile("dvb:  LockedInOnSignal locked: {0}, present: {1}, quality: {2}, strength: {3}", isLocked, isPresent, quality, strength);
+            if (isLocked || (isPresent && (quality > 0 || strength > 0)))
             {
-              break;
+                isLocked = true;
+                break;
             }
           }
           catch (COMException)
@@ -2341,6 +2351,14 @@
       _interfaceEpgGrabber.SetCallBack(callback);
       _interfaceEpgGrabber.GrabEPG();
       _interfaceEpgGrabber.GrabMHW();
+
+      // If grabbing for a provider (Sky UK/Italy)
+      if (callback.EPGGrabMode == BaseEpgGrabber.eEPGGrabMode.SkyUK)
+        _interfaceEpgGrabber.ActivateSkyEpgGrabber(SkyUK.Instance.InternalId);
+
+      else if (callback.EPGGrabMode == BaseEpgGrabber.eEPGGrabMode.SkyItaly)
+        _interfaceEpgGrabber.ActivateSkyEpgGrabber(SkyItaly.Instance.InternalId);
+
       _epgGrabbing = true;
     }
 
@@ -2389,6 +2407,143 @@
         //if (!CheckThreadId()) return null;
         try
         {
+          byte isSkyEpgGrabbingActive = 0;
+          byte isSkyEpgReady = 0;
+          byte hasSkyEpgGrabbingAborted = 0;
+          _interfaceEpgGrabber.IsSkyEpgGrabberActive(ref isSkyEpgGrabbingActive);
+          _interfaceEpgGrabber.IsSkyEpgReady(ref isSkyEpgReady);
+          _interfaceEpgGrabber.HasSkyEpgAborted(ref hasSkyEpgGrabbingAborted);
+
+          List<EpgChannel> epgChannels = new List<EpgChannel>();
+
+          if (isSkyEpgGrabbingActive == 1 && hasSkyEpgGrabbingAborted == 1)
+          {
+            Log.Log.Write("Sky EPG grabbing detected as being aborted");
+
+            _interfaceEpgGrabber.ResetSkyEpgRetrieval();
+            _interfaceEpgGrabber.Reset();
+            return epgChannels;
+          }
+
+          if (isSkyEpgGrabbingActive == 1 && isSkyEpgReady == 1)
+          {
+            //  Reset the epg retrieval
+            _interfaceEpgGrabber.ResetSkyEpgRetrieval();
+
+            byte atEndChannel = 0;
+            ushort channelId = 0;
+            ushort networkId = 0;
+            ushort transportId = 0;
+            ushort serviceId = 0;
+            int numberSkyEpgEventsRetrieved = 0;
+
+            //  Get the first channel
+            _interfaceEpgGrabber.GetNextSkyEpgChannel(ref atEndChannel, ref channelId, ref networkId, ref transportId, ref serviceId);
+
+            //  While we have more channels to retrieve
+            while (atEndChannel == 0)
+            {
+              byte atEndChannelEvent = 0;
+              ushort eventId = 0;
+              ushort mjdStart = 0;
+              uint startTime = 0;
+              uint duration = 0;
+              IntPtr titlePtr;
+              IntPtr summaryPtr;
+              IntPtr themePtr;
+              ushort seriesId = 0;
+              byte seriesTermination = 0;
+
+              //  Get the first event for this channel
+              _interfaceEpgGrabber.GetNextSkyEpgChannelEvent(ref atEndChannelEvent, ref eventId, ref mjdStart, ref startTime, ref duration, out titlePtr, out summaryPtr, out themePtr, ref seriesId, ref seriesTermination);
+
+              //  Try to find this channel
+              EpgChannel skyEpgChannel = null;
+              
+              if(atEndChannelEvent == 0)
+              {
+                skyEpgChannel = new EpgChannel();
+
+                //  Add and populate the epg channel
+                epgChannels.Add(skyEpgChannel);
+
+                DVBBaseChannel baseChannel = new DVBSChannel();
+                baseChannel.NetworkId = networkId;
+                baseChannel.TransportId = transportId;
+                baseChannel.ServiceId = serviceId;
+                baseChannel.Name = string.Empty;
+
+                skyEpgChannel.Channel = baseChannel;
+              }
+
+              while (atEndChannelEvent == 0)
+              {
+                //  Validate the timestamps
+                if (mjdStart != 0 && duration != 0)
+                {
+                  //  Convert modified Julian day and calculate start and end time
+                  DateTime programStartDay = (new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).AddSeconds((mjdStart + 2400000.5 - 2440587.5) * 86400);
+                  DateTime programStartTime = programStartDay.AddSeconds(startTime);
+
+                  //  Start time is in UTC, need to convert to local time
+                  programStartTime = programStartTime.ToLocalTime();
+                    
+                  //  Calculate end time
+                  DateTime programEndTime = programStartTime.AddSeconds(duration);
+
+                  string title = string.Empty;
+                  string summary = string.Empty;
+                  string theme = string.Empty;
+
+                  if (titlePtr != IntPtr.Zero)
+                    title = DvbTextConverter.Convert(titlePtr, "");
+
+                  if (summaryPtr != IntPtr.Zero)
+                    summary = DvbTextConverter.Convert(summaryPtr, "");
+
+                  if (themePtr != IntPtr.Zero)
+                    theme = DvbTextConverter.Convert(themePtr, "");
+
+                  //  Populate and add the program
+                  EpgProgram skyProgram = new EpgProgram(programStartTime, programEndTime);
+                  EpgLanguageText skyProgramLang = new EpgLanguageText("ALL", title, summary, theme, 0, "", -1);
+                  skyProgram.Text.Add(skyProgramLang);
+
+                  //  Add the series id, if applicable
+                  if (seriesId != 0)
+                  {
+                    skyProgram.SeriesId = seriesId;
+                    skyProgram.SeriesTermination = seriesTermination;
+                  }
+
+                  skyEpgChannel.Programs.Add(skyProgram);
+
+                  numberSkyEpgEventsRetrieved++;
+                }
+
+                //  Get the next channel event
+                _interfaceEpgGrabber.GetNextSkyEpgChannelEvent(ref atEndChannelEvent, ref eventId, ref mjdStart, ref startTime, ref duration, out titlePtr, out summaryPtr, out themePtr, ref seriesId, ref seriesTermination);
+              }
+
+              //  Sort the programs
+              if (skyEpgChannel != null)
+                skyEpgChannel.Sort();
+
+              //  Get the next channel
+              _interfaceEpgGrabber.GetNextSkyEpgChannel(ref atEndChannel, ref channelId, ref networkId, ref transportId, ref serviceId);
+            }
+
+            Log.Log.Epg("Retrieved EPG events for " + epgChannels.Count.ToString() + " channels");
+            Log.Log.Epg("Number of Sky epg events retrieved: " + numberSkyEpgEventsRetrieved.ToString());
+
+            //  Reset to clear utilised memory
+            _interfaceEpgGrabber.Reset();
+
+            //  All done!  Return the epg channels and the program data!
+            return epgChannels;
+          }
+
+
           bool dvbReady, mhwReady;
           _interfaceEpgGrabber.IsEPGReady(out dvbReady);
           _interfaceEpgGrabber.IsMHWReady(out mhwReady);
@@ -2400,7 +2555,6 @@
           mhwReady = titleCount > 10;
           _interfaceEpgGrabber.GetEPGChannelCount(out channelCount);
           dvbReady = channelCount > 0;
-          List<EpgChannel> epgChannels = new List<EpgChannel>();
           Log.Log.Epg("dvb:mhw ready MHW {0} titles found", titleCount);
           Log.Log.Epg("dvb:dvb ready.EPG {0} channels", channelCount);
           if (mhwReady)
@@ -2483,6 +2637,7 @@
             return epgChannels;
           }
 
+
           if (dvbReady)
           {
             ushort networkid = 0;
Index: TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/Provider.cs
===================================================================
--- TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/Provider.cs	(revision 0)
+++ TvEngine3/TVLibrary/TVLibrary/Implementations/Helper/Providers/Provider.cs	(revision 0)
@@ -0,0 +1,128 @@
+// Copyright (C) 2005-2010 Team MediaPortal
+// http://www.team-mediaportal.com
+// 
+// MediaPortal is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 2 of the License, or
+// (at your option) any later version.
+// 
+// MediaPortal is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+// 
+// You should have received a copy of the GNU General Public License
+// along with MediaPortal. If not, see <http://www.gnu.org/licenses/>.
+
+
+using System;
+using System.Collections.Generic;
+using TvLibrary.Interfaces;
+using TvLibrary.Interfaces.Analyzer;
+using TvLibrary.Channels;
+using TvDatabase;
+
+namespace TvLibrary.Implementations.Helper.Providers
+{
+  public class Provider
+  {
+    #region Fields
+
+    /// <summary>
+    /// Singleton
+    /// </summary>
+    private static readonly Provider _instance = new Provider();
+
+    #endregion
+
+    #region Properties
+
+    /// <summary>
+    /// Gets the singleton instance
+    /// </summary>
+    public static Provider Instance
+    {
+      get
+      {
+        return _instance;
+      }
+    }
+
+    /// <summary>
+    /// Gets if at least 1 provider has EPG grabbing enabled
+    /// </summary>
+    public bool ProviderEPGGrabbingEnabled
+    {
+      get
+      {
+        return SkyUK.Instance.EPGGrabbingEnabled || SkyItaly.Instance.EPGGrabbingEnabled;
+      }
+    }
+
+    #endregion
+
+    #region Methods
+
+    /// <summary>
+    /// Protected cstr
+    /// </summary>
+    protected Provider()
+    { }
+
+    /// <summary>
+    /// Sets a setting value
+    /// </summary>
+    /// <param name="name"></param>
+    /// <param name="value"></param>
+    protected void SetSetting(string name, object value)
+    {
+      TvBusinessLayer layer = new TvBusinessLayer();
+
+      string valueString;
+
+      if (value is bool)
+        valueString = (((bool)value) ? "true" : "false");
+      else
+        valueString = value.ToString();
+
+      Setting setting = layer.GetSetting(name);
+      setting.Value = valueString;
+      setting.Persist();
+    }
+
+    /// <summary>
+    /// Gets a setting value
+    /// </summary>
+    /// <typeparam name="T"></typeparam>
+    /// <param name="name"></param>
+    /// <returns></returns>
+    protected T GetSetting<T>(string name, T defaultValue)
+    {
+      TvBusinessLayer layer = new TvBusinessLayer();
+
+      if (typeof(T) == typeof(int))
+      {
+        int parsedIntValue = (int)(object)defaultValue;
+
+        int.TryParse(layer.GetSetting(name, parsedIntValue.ToString()).Value, out parsedIntValue);
+        return (T)(object)parsedIntValue;
+      }
+
+      if (typeof(T) == typeof(bool))
+      {
+        bool parsedBoolValue = (layer.GetSetting(name, ((bool)(object)defaultValue ? "true" : "false")).Value == "true" ? true : false);
+
+        return (T)(object)parsedBoolValue;
+      }
+
+      if (typeof(T) == typeof(string))
+      {
+        return (T)(object)layer.GetSetting(name, (string)(object)defaultValue).Value;
+      }
+
+      throw new Exception("Invalid type");
+    }
+
+    #endregion
+  }
+}
